<?xml version="1.0" encoding="utf-8"?>
<?ICEA pattern?>
<!-- Notices - Distribution Notice: 
           This document has been approved for Public Release and is available for use without restriction.
       -->
<sch:pattern xmlns:ism="urn:us:gov:ic:ism" xmlns:sch="http://purl.oclc.org/dsdl/schematron" id="IC-SF-ID-00002">
    <sch:p class="ruleText" ism:ownerProducer="USA" ism:classification="U">
        [IC-SF-ID-00002][Error] The number of icsfhashv:BlockHash is equal to the number in @icsfhashv:totalBlocks.
    </sch:p>
    <sch:p class="codeDesc" ism:ownerProducer="USA" ism:classification="U">
        This rule ensures that the number of icsfhashv:BlockHash is equal to the number in @icsfhashv:totalBlocks.
    </sch:p>
    <sch:rule id="IC-SF-ID-00002-R1" context="icsfhashv:HashVerification | icsfhashv:ContentEncodedHashVerification | icsfhashv:ContentDecodedHashVerification">
        <sch:assert test="if (exists(icsfhashv:TotalHash) and exists(icsfhashv:BlockHash)) then count(icsfhashv:BlockHash) = icsfhashv:TotalHash/@icsfhashv:totalBlocks else true()"
            flag="error" role="error">
            [IC-SF-ID-00002][Error] The number of icsfhashv:BlockHash (<sch:value-of select="count(icsfhashv:BlockHash)"/>)
            must equal the number in icsfhashv:TotalHash/@icsfhashv:totalBlocks (<sch:value-of select="icsfhashv:TotalHash/@icsfhashv:totalBlocks"/>).</sch:assert>
    </sch:rule>
</sch:pattern>
